package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.InternalEntry.Type;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in proc_vs_func.p).
 */
public class ProcVsFunc
{
   private static final InvokeConfig RUN_CALL_SITE_1 = new InvokeConfig().setTarget("proc0").setModes("I");

   @LegacySignature(type = Type.VARIABLE, name = "flag")
   logical flag = UndoableFactory.logical(true);

   @LegacySignature(type = Type.VARIABLE, name = "l1")
   int64 l1 = UndoableFactory.int64();

   @LegacySignature(type = Type.VARIABLE, name = "l2")
   int64 l2 = UndoableFactory.int64();

   @LegacySignature(type = Type.VARIABLE, name = "i")
   integer i = UndoableFactory.integer();

   @LegacySignature(type = Type.VARIABLE, name = "num")
   integer num = UndoableFactory.integer();

   @LegacySignature(type = Type.VARIABLE, name = "obj")
   object<? extends com.goldencode.hotel.oo.Foo> obj = UndoableFactory.object(com.goldencode.hotel.oo.Foo.class);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in proc_vs_func.p).
    */
   @LegacySignature(type = Type.MAIN, name = "proc_vs_func.p")
   public void execute()
   {
      externalProcedure(ProcVsFunc.this, new Block((Init) () -> 
      {
         ObjectOps.register(obj);
      }, 
      (Body) () -> 
      {
         obj.assign(ObjectOps.newInstance(com.goldencode.hotel.oo.Foo.class));
         l1.assign(date.elapsed());
         
         ToClause toClause0 = new ToClause(i, 1, 1000000);
         
         doTo("loopLabel1", toClause0, new Block((Body) () -> 
         {
            RUN_CALL_SITE_1.clone().run(i);
         }));
         
         l2.assign(date.elapsed());
         message(concat("proc0 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         ToClause toClause1 = new ToClause(i, 1, 1000000);
         
         doTo("loopLabel2", toClause1, new Block((Body) () -> 
         {
            func0(i);
         }));
         
         l2.assign(date.elapsed());
         message(concat("func0 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         ToClause toClause2 = new ToClause(i, 1, 1000000);
         
         doTo("loopLabel3", toClause2, new Block((Body) () -> 
         {
            func1(i);
         }));
         
         l2.assign(date.elapsed());
         message(concat("func1 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         ToClause toClause3 = new ToClause(i, 1, 1000000);
         
         doTo("loopLabel4", toClause3, new Block((Body) () -> 
         {
            func2(i);
         }));
         
         l2.assign(date.elapsed());
         message(concat("func2 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel5:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            obj.ref().m1(i);
         }
         
         l2.assign(date.elapsed());
         message(concat("m1 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel6:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            obj.ref().m2(i);
         }
         
         l2.assign(date.elapsed());
         message(concat("m2 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel7:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            obj.ref().m3(i);
         }
         
         l2.assign(date.elapsed());
         message(concat("m3 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel8:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            num.assign(obj.ref().getTest1());
         }
         
         l2.assign(date.elapsed());
         message(concat("prop test1 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel9:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            num.assign(obj.ref().getTest2());
         }
         
         l2.assign(date.elapsed());
         message(concat("prop test2 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel10:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            num.assign(obj.ref().getTest3());
         }
         
         l2.assign(date.elapsed());
         message(concat("prop test3 ", valueOf(minus(l2, l1)), new character(" ms")));
         l1.assign(date.elapsed());
         
         loopLabel11:
         for (i.assign(1); _isLessThanOrEqual(i, 1000000); i.increment())
         {
            num.assign(obj.ref().getTest4());
         }
         
         l2.assign(date.elapsed());
         message(concat("prop test4 ", valueOf(minus(l2, l1)), new character(" ms")));
      }));
   }

   @LegacySignature(type = Type.PROCEDURE, name = "proc0", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public void proc0(final integer _num)
   {
      integer num = UndoableFactory.initInput(_num);
      
      internalProcedure(ProcVsFunc.this, "proc0", new Block());
   }

   @LegacySignature(type = Type.FUNCTION, name = "func0", returns = "INTEGER", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public integer func0(final integer _num)
   {
      integer num = TypeFactory.initInput(_num);
      
      return function(this, "func0", integer.class, new Block((Body) () -> 
      {
         returnNormal(0);
      }));
   }

   @LegacySignature(type = Type.FUNCTION, name = "func1", returns = "INTEGER", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public integer func1(final integer _num)
   {
      integer num = TypeFactory.initInput(_num);
      
      return function(this, "func1", integer.class, new Block((Body) () -> 
      {
         if ((flag).booleanValue())
         {
            returnNormal(0);
         }
      }));
   }

   @LegacySignature(type = Type.FUNCTION, name = "func2", returns = "INTEGER", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public integer func2(final integer _num)
   {
      integer num = TypeFactory.initInput(_num);
      
      return function(this, "func2", integer.class, new Block((Body) () -> 
      {
         repeat("loopLabel0", new Block((Body) () -> 
         {
            returnNormal(0);
         }));
      }));
   }
}
